
precision mediump float;
varying vec2 varyTexCoord;
varying vec2 varyTexCoordBackgr;
varying vec2 varyTexCoordNormal0;
varying vec2 varyTexCoordNormal1;
varying vec2 varyTexCoordNormal2;

uniform sampler2D texPhi;
uniform sampler2D texUV;
uniform sampler2D texBackgr;
uniform sampler2D texNormal;
uniform sampler2D texPaint;

uniform vec3 uWaterColor;
uniform vec4 uRippleStrAndBackgrScale; // x, y - ripple strengths speed dependent/independend; zw - background image scale
uniform vec3 uTransp_BlurWidth_SpecStrength;
uniform vec4 uGridSizeAndInv;

uniform vec3 uPaintColor0;
uniform vec3 uPaintColor1;
uniform vec3 uPaintColor2;

void main()
{
	vec3 uv_phi = texture2D(texUV, varyTexCoord).rgb;
	float phi = uv_phi.b;
	//float phi = phiBicubic();
	
	phi = phi * 5.0 - 4.0; // [-4:1]
	//gl_FragColor = vec4(phi, 0.0, 0.0, 1.0);
	//return;

	vec4 backgrSample = texture2D(texBackgr, varyTexCoordBackgr);
	
	vec3 paintDensities = texture2D(texPaint, varyTexCoord).rgb;
	
	float blurWidth = uTransp_BlurWidth_SpecStrength.y;
	if(phi > blurWidth)
	{
		gl_FragColor = backgrSample;
	}
	else
	{
		
	
		// GOOD COLOR!  vec4(0.6, 0.85, 0.93, 1.0)
		//float t = clamp(-phi * 0.45, 0.7, 0.9);
		float t = smoothstep(0.0, 3.0, -phi);
		float transp = uTransp_BlurWidth_SpecStrength.x * (0.8 + 0.2 * t);
		gl_FragColor = backgrSample * transp + ( vec4(uWaterColor, 1.0) ) * (1.0 - transp);
		
		paintDensities *= t;
		vec3 paint = paintDensities.r * uPaintColor0 + paintDensities.g * uPaintColor1 + paintDensities.b * uPaintColor2;
		float paintAmount = min(paintDensities.r + paintDensities.g + paintDensities.b, 1.0);
		gl_FragColor.rgb = paint + (1.0 - paintAmount) * gl_FragColor.rgb;
		
			
		if(phi > -blurWidth) // questionable if. Seems to help a bit on Ainol, not so much on SGS
		{
			t = smoothstep(-blurWidth, blurWidth, phi);
			gl_FragColor = (1.0-t) * gl_FragColor + (t) * backgrSample;
		}
		
		
		
	}
	
	
}
